﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HSDc.DefinitionTransformer.DTO
{
    public enum ElementType
    {
        Action,
        Activity,
        Decision,
        Partition,
        StartPoint,
        EndPoint,
        Transition,
        Fork,
        Join
    }

    public class DiagramElement
    {
        private int id;

        public int Id
        {
            get { return id; }
            set { id = value; }
        }

        private string _name;

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        private int _parentId;

        public int ParentId
        {
            get { return _parentId; }
            set { _parentId = value; }
        }

        private ElementType _type;

        public ElementType Type
        {
            get { return _type; }
            set { _type = value; }
        }

    }

    public class Connector : DiagramElement 
    {

        private int _targetElementId;

        public int TargetElementId
        {
            get { return _targetElementId; }
            set { _targetElementId = value; }
        }
        private int _sourceElementId;

        public int SourceElementId
        {
            get { return _sourceElementId; }
            set { _sourceElementId = value; }
        }

        private string _constraint;

        public string Constraint
        {
            get { return _constraint; }
            set { _constraint = value; }
        }
    
    
    }



}
